diff -uNrd ircd-hybrid-6.0/src/channel.c ircd-pi1.0a/src/channel.c
--- ircd-hybrid-6.0/src/channel.c	Sun Nov 26 23:11:49 2000
+++ ircd-pi1.0a/src/channel.c	Thu May 23 00:22:22 2002
@@ -34,7 +34,7 @@
  *                mode * -p etc. if flag was clear
  *
  *
- * $Id: channel.c,v 1.186 2000/11/27 04:11:49 lusky Exp $
+ * $Id: channel.c,v 1.13 2002/05/23 04:22:22 smoli Exp $
  */
 #include "channel.h"
 #include "client.h"
@@ -49,11 +49,13 @@
 #include "send.h"
 #include "struct.h"
 #include "whowas.h"
+#include "config.h"
 
 #include <assert.h>
 #include <string.h>
 #include <stdlib.h>
 
+#define OLD_NON_RED
 #ifdef NEED_SPLITCODE
 
 static void check_still_split();
@@ -395,9 +397,9 @@
     return -1;
   for (ban = &(chptr->banlist); *ban; ban = &((*ban)->next))
 #ifdef BAN_INFO
-    if (irccmp(banid, (*ban)->value.banptr->banstr)==0)
+    if (strcmp(banid, (*ban)->value.banptr->banstr)==0)
 #else
-      if (irccmp(banid, (*ban)->value.cp)==0)
+      if (strcmp(banid, (*ban)->value.cp)==0)
 #endif
         {
           tmp = *ban;
@@ -433,7 +435,7 @@
   if (!eid)
     return -1;
   for (ex = &(chptr->exceptlist); *ex; ex = &((*ex)->next))
-    if (irccmp(eid, BANSTR(*ex)) == 0)
+    if (strcmp(eid, BANSTR(*ex)) == 0)
       {
         tmp = *ex;
         *ex = tmp->next;
@@ -804,6 +806,30 @@
   return 0;
 }
 
+#ifdef HAVE_SSL
+int is_ssl_channel(struct Channel *chptr)
+{
+  Link  *lp;
+  
+  if(chptr)
+    {
+      if((lp = chptr->members))
+        {
+          do
+            if(!IsSSLUmode(lp->value.cptr))
+              return 0;
+          while((lp = lp->next));
+          
+          return 1;
+        }
+      else
+        return 0;
+    }
+  else
+    return 0;
+}
+#endif
+
 /*
  * write the "simple" list of channel modes for channel chptr onto buffer mbuf
  * with the parameters in pbuf.
@@ -811,8 +837,27 @@
 void channel_modes(struct Client *cptr, char *mbuf, char *pbuf, struct Channel *chptr)
 {
   *mbuf++ = '+';
-  if (chptr->mode.mode & MODE_SECRET)
-    *mbuf++ = 's';
+  
+  if(chptr->mode.mode & MODE_INVITEONLY)
+    *mbuf++ = 'i';
+  
+  if(*chptr->mode.key)
+    {
+      *mbuf++ = 'k';
+      if (IsMember(cptr, chptr) || IsServer(cptr))
+        (void)strcat(pbuf, chptr->mode.key);
+    }
+  if(chptr->mode.limit)
+    {
+      *mbuf++ = 'l';
+      if (IsMember(cptr, chptr) || IsServer(cptr))
+        ircsprintf(pbuf, "%d ", chptr->mode.limit);
+    }
+  
+  if(chptr->mode.mode & MODE_MODERATED)
+    *mbuf++ = 'm';
+  if(chptr->mode.mode & MODE_NOPRIVMSGS)
+    *mbuf++ = 'n';
 
   /* bug found by "is" ejb@debian.org */
 #ifdef OLD_P_S
@@ -823,26 +868,18 @@
     *mbuf++ = 'p';
 #endif
 
-  if (chptr->mode.mode & MODE_MODERATED)
-    *mbuf++ = 'm';
-  if (chptr->mode.mode & MODE_TOPICLIMIT)
+  if(chptr->mode.mode & MODE_SECRET)
+    *mbuf++ = 's';
+  if(chptr->mode.mode & MODE_TOPICLIMIT)
     *mbuf++ = 't';
-  if (chptr->mode.mode & MODE_INVITEONLY)
-    *mbuf++ = 'i';
-  if (chptr->mode.mode & MODE_NOPRIVMSGS)
-    *mbuf++ = 'n';
-  if (chptr->mode.limit)
-    {
-      *mbuf++ = 'l';
-      if (IsMember(cptr, chptr) || IsServer(cptr))
-        ircsprintf(pbuf, "%d ", chptr->mode.limit);
-    }
-  if (*chptr->mode.key)
-    {
-      *mbuf++ = 'k';
-      if (IsMember(cptr, chptr) || IsServer(cptr))
-        (void)strcat(pbuf, chptr->mode.key);
-    }
+  
+#ifdef HAVE_SSL
+  if(IsSSLOnlyChannel(chptr))
+    *mbuf++ = 'x';
+  if(IsSSLChannel(chptr))
+    *mbuf++ = 'z';
+#endif
+  
   *mbuf++ = '\0';
   return;
 }
@@ -1180,17 +1217,37 @@
   int   chan_op;
   int   self_lose_ops;
   int   user_mode;
+  int   who_mode;
+#ifdef ENFORCE
+  int   enforced = 0; /* MODE has been enforced */
 
+#endif /* ENFORCE */
   self_lose_ops = 0;
 
   user_mode = user_channel_mode(sptr, chptr);
   chan_op = (user_mode & CHFL_CHANOP);
+#ifdef ENFORCE
+             /* a server doesn't enforce */
+  enforced = !IsServer(sptr) && !chan_op &&
+             /* remote enforcer */
+             (IsServer(cptr) ||
+             /* local enforcer */
+               IsEnforce(sptr));
+#endif
 
   /* has ops or is a server */
-  ischop = IsServer(sptr) || chan_op;
+  ischop = IsServer(sptr) || 
+#ifdef ENFORCE
+           enforced ||
+#endif
+           chan_op;
 
   /* is client marked as deopped */
-  isdeop = !ischop && !IsServer(sptr) && (user_mode & CHFL_DEOPPED);
+  isdeop = !ischop && !IsServer(sptr) &&
+#ifdef ENFORCE
+           !enforced &&
+#endif
+           (user_mode & CHFL_DEOPPED);
 
   /* is an op or server or remote user on a TS channel */
   isok = ischop || (!isdeop && IsServer(cptr) && chptr->channelts);
@@ -1247,105 +1304,128 @@
 
         case 'o' :
         case 'v' :
-          if (MyClient(sptr))
-            {
-              if(!IsMember(sptr, chptr))
-                {
-                  if(!errsent(SM_ERR_NOTONCHANNEL, &errors_sent))
-                    sendto_one(sptr, form_str(ERR_NOTONCHANNEL),
-                               me.name, sptr->name, chptr->chname);
-                  /* eat the parameter */
-                  parc--;
-                  parv++;
-                  break;
-                }
+          if(MyClient(sptr))
+          {
+            if(!IsMember(sptr, chptr)
+#ifdef ENFORCE
+               && !enforced
+#endif
+               )
+              {
+                if(!errsent(SM_ERR_NOTONCHANNEL, &errors_sent))
+                   sendto_one(sptr, form_str(ERR_NOTONCHANNEL),
+                              me.name, sptr->name, chptr->chname);
+                /* eat the parameter */
+                parc--;
+                parv++;
+                break;
+              }
 #ifdef LITTLE_I_LINES
-              else
-                {
-                  if(IsRestricted(sptr) && (whatt == MODE_ADD))
-                    {
-                      if(!errsent(SM_ERR_RESTRICTED, &errors_sent))
-                        {
-                          sendto_one(sptr,
-            ":%s NOTICE %s :*** Notice -- You are restricted and cannot chanop others",
-                                 me.name,
-                                 sptr->name);
-                        }
-                      /* eat the parameter */
-                      parc--;
-                      parv++;
-                      break;
-                    }
-                }
+            else
+              if(IsRestricted(sptr) && (whatt == MODE_ADD) && !enforced)
+              {
+                if(!errsent(SM_ERR_RESTRICTED, &errors_sent))
+                   sendto_one(sptr,
+                              ":%s NOTICE %s :*** Notice -- You are restricted and cannot chanop others",
+                              me.name,
+                              sptr->name);
+                  /* eat the parameter */
+                parc--;
+                parv++;
+                break;
+              }
 #endif
-            }
-          if (whatt == MODE_QUERY)
+          }
+
+          if(whatt == MODE_QUERY)
             break;
-          if (parc-- <= 0)
+          if(parc-- <= 0)
             break;
           arg = check_string(*parv++);
 
-          if (MyClient(sptr) && opcnt >= MAXMODEPARAMS)
+          if(MyClient(sptr) && opcnt >= MAXMODEPARAMS)
             break;
 
-          if (!(who = find_chasing(sptr, arg, NULL)))
+          if(!(who = find_chasing(sptr, arg, NULL)))
             break;
 
           /* there is always the remote possibility of picking up
            * a bogus user, be nasty to core for that. -Dianora
            */
 
-          if (!who->user)
+          if(!who->user)
             break;
 
           /* no more of that mode bouncing crap */
           if (!IsMember(who, chptr))
-            {
-              if (MyClient(sptr))
-                sendto_one(sptr, form_str(ERR_USERNOTINCHANNEL), me.name, 
-                           sptr->name, arg, chptr->chname);
-              break;
-            }
-
-          if ((who == sptr) && (c == 'o'))
-            {
-              if(whatt == MODE_ADD)
-                break;
-              
-              if(whatt == MODE_DEL)
-                self_lose_ops = 1;
-              }
+          {
+            if(MyClient(sptr))
+              sendto_one(sptr, form_str(ERR_USERNOTINCHANNEL), me.name, 
+                         sptr->name, arg, chptr->chname);
+            break;
+          }
 
-          /* ignore server-generated MODE +-ovh */
-          if (IsServer(sptr))
-            {
-              ts_warn( "MODE %c%c on %s for %s from server %s (ignored)", 
-                       (whatt == MODE_ADD ? '+' : '-'), c, chptr->chname, 
-                       who->name,sptr->name);
+          if((who == sptr) && (c == 'o'))
+          {
+            if(whatt == MODE_ADD && chan_op)
               break;
-            }
+            if(whatt == MODE_DEL && !chan_op)
+	      break;
+            if(whatt == MODE_ADD
+#ifdef ENFORCE
+               && !enforced
+#endif
+               )
+	      break;
+            if(whatt == MODE_DEL)
+              self_lose_ops = 1;
+          }
 
           if (c == 'o')
             the_mode = MODE_CHANOP;
           else if (c == 'v')
             the_mode = MODE_VOICE;
+          
+          /* code for non-redundant op/voice */
+          who_mode = user_channel_mode(who, chptr);
+          
+          if(the_mode == MODE_CHANOP)
+            {              
+              if((who_mode & CHFL_CHANOP) && whatt == MODE_ADD)
+                break;
+              
+              if(!(who_mode & CHFL_CHANOP) && whatt == MODE_DEL)
+                 break;
+            }
+          else if(the_mode == MODE_VOICE)
+            {
+              if((who_mode & CHFL_VOICE) && whatt == MODE_ADD)
+                break;
+              
+              if(!(who_mode & CHFL_VOICE) && whatt == MODE_DEL)
+                break;
+            }      
 
           if (isdeop && (c == 'o') && whatt == MODE_ADD)
             set_deopped(who, chptr, the_mode);
 
 #ifdef HIDE_OPS
 	  if(the_mode == MODE_CHANOP && whatt == MODE_DEL)
-	    sendto_one(who,":%s MODE %s -o %s",
-		       sptr->name,chptr->chname,who->name);
+	    sendto_one(who, ":%s MODE %s -o %s",
+		       sptr->name, chptr->chname, who->name);
 #endif
 
-          if (!isok)
-            {
-              if (MyClient(sptr) && !errsent(SM_ERR_NOOPS, &errors_sent))
-                sendto_one(sptr, form_str(ERR_CHANOPRIVSNEEDED), me.name, 
-                           sptr->name, chptr->chname);
-              break;
-            }
+          if(!isok
+#ifdef ENFORCE
+             && !enforced
+#endif
+            )
+          {
+            if(MyClient(sptr) && !errsent(SM_ERR_NOOPS, &errors_sent))
+              sendto_one(sptr, form_str(ERR_CHANOPRIVSNEEDED), me.name, 
+                         sptr->name, chptr->chname);
+            break;
+          }
         
           tmp = strlen(arg);
           if (len + tmp + 2 >= MODEBUFLEN)
@@ -1361,7 +1441,11 @@
 
           change_chan_flag(chptr, who, the_mode|whatt);
 
-          if (self_lose_ops)
+          if(self_lose_ops
+#ifdef ENFORCE
+             && !enforced
+#endif
+            )
             isok = 0;
 
           break;
@@ -1380,9 +1464,7 @@
           else
             {
               if (whatt == MODE_DEL)
-                {
                   arg = check_string(*parv++);
-                }
               else
                 {
                   if MyClient(sptr)
@@ -1392,37 +1474,39 @@
                 }
             }
 
-          if (keychange++)
-            break;
-          /*      if (MyClient(sptr) && opcnt >= MAXMODEPARAMS)
+          if(keychange++)
             break;
-            */
-          if (!*arg)
+
+	  if(!*arg)
             break;
 
-          if (!isok)
-            {
-              if (!errsent(SM_ERR_NOOPS, &errors_sent) && MyClient(sptr))
-                sendto_one(sptr, form_str(ERR_CHANOPRIVSNEEDED), me.name, 
-                           sptr->name, chptr->chname);
-              break;
-            }
+          if(!isok
+#ifdef ENFORCE
+             && !enforced
+#endif
+            )
+          {	    
+            if(MyClient(sptr) && !errsent(SM_ERR_NOOPS, &errors_sent))
+              sendto_one(sptr, form_str(ERR_CHANOPRIVSNEEDED), me.name, 
+                         sptr->name, chptr->chname);
+            break; 
+          }
 
 #ifdef OLD_MODE_K
-          if ((whatt == MODE_ADD) && (*chptr->mode.key))
-            {
-              sendto_one(sptr, form_str(ERR_KEYSET), me.name, 
-                         sptr->name, chptr->chname);
-              break;
-            }
+          if((whatt == MODE_ADD) && (*chptr->mode.key))
+          {
+            sendto_one(sptr, form_str(ERR_KEYSET), me.name, 
+                       sptr->name, chptr->chname);
+            break;
+          }
 #endif
-          if ( (tmp = strlen(arg)) > KEYLEN)
-            {
-              arg[KEYLEN] = '\0';
-              tmp = KEYLEN;
-            }
+          if((tmp = strlen(arg)) > KEYLEN)
+          {
+            arg[KEYLEN] = '\0';
+            tmp = KEYLEN;
+          }
 
-          if (len + tmp + 2 >= MODEBUFLEN)
+          if(len + tmp + 2 >= MODEBUFLEN)
             break;
 
 #ifndef OLD_MODE_K
@@ -1500,7 +1584,7 @@
               /* don't allow a non chanop to see the exception list
                * suggested by Matt on operlist nov 25 1998
                */
-              if(isok)
+              if(isok || IsEnforce(cptr))
                 {
 #ifdef BAN_INFO
                   for (lp = chptr->exceptlist; lp; lp = lp->next)
@@ -1526,7 +1610,8 @@
                   sendto_one(sptr, form_str(ERR_CHANOPRIVSNEEDED), me.name, 
                                sptr->name, chptr->chname);
                 }
-              break;
+
+	      break;
             }
           arg = check_string(*parv++);
 
@@ -1535,11 +1620,19 @@
 
           if (!isok)
             {
-              if (!errsent(SM_ERR_NOOPS, &errors_sent) && MyClient(sptr))
-                sendto_one(sptr, form_str(ERR_CHANOPRIVSNEEDED),
-                           me.name, sptr->name, 
-                           chptr->chname);
-              break;
+#ifdef ENFORCE
+	      if(!IsEnforce(sptr))
+	      {	    
+#endif /* ENFORCE */
+                if (MyClient(sptr) && !errsent(SM_ERR_NOOPS, &errors_sent))
+                  sendto_one(sptr, form_str(ERR_CHANOPRIVSNEEDED), me.name, 
+                             sptr->name, chptr->chname);
+                break;
+#ifdef ENFORCE
+	      } else {	    
+		enforced = 1;
+	      }
+#endif /* ENFORCE */
             }
           
           if(MyClient(sptr))
@@ -1640,11 +1733,19 @@
 
           if (!isok)
             {
-              if (!errsent(SM_ERR_NOOPS, &errors_sent) && MyClient(sptr))
-                sendto_one(sptr, form_str(ERR_CHANOPRIVSNEEDED),
-                           me.name, sptr->name, 
-                           chptr->chname);
-              break;
+#ifdef ENFORCE
+	      if(!IsEnforce(sptr))
+	      {	    
+#endif /* ENFORCE */
+                if (MyClient(sptr) && !errsent(SM_ERR_NOOPS, &errors_sent))
+                  sendto_one(sptr, form_str(ERR_CHANOPRIVSNEEDED), me.name, 
+                             sptr->name, chptr->chname);
+                break;
+#ifdef ENFORCE
+	      } else {	    
+		enforced = 1;
+	      }
+#endif /* ENFORCE */
             }
           
           if(MyClient(sptr))
@@ -1754,14 +1855,21 @@
 
           if (!isok)
             {
-              if (!errsent(SM_ERR_NOOPS, &errors_sent) && MyClient(sptr))
-                sendto_one(sptr, form_str(ERR_CHANOPRIVSNEEDED),
-                           me.name, sptr->name, 
-                           chptr->chname);
-              break;
+#ifdef ENFORCE
+	      if(!IsEnforce(sptr))
+	      {	    
+#endif /* ENFORCE */
+                if (MyClient(sptr) && !errsent(SM_ERR_NOOPS, &errors_sent))
+                  sendto_one(sptr, form_str(ERR_CHANOPRIVSNEEDED), me.name, 
+                             sptr->name, chptr->chname);
+                break;
+#ifdef ENFORCE
+	      } else {	    
+		enforced = 1;
+	      }
+#endif /* ENFORCE */
             }
 
-
           /* Ignore colon at beginning of ban string.
            * Unfortunately, I can't ignore all such strings,
            * because otherwise the channel could get desynced.
@@ -1781,22 +1889,22 @@
           /* user-friendly ban mask generation, taken
           ** from Undernet's ircd  -orabidoo
           */
-          if (MyClient(sptr))
+          if(MyClient(sptr))
+          {
+            if( (*arg == ':') && (whatt & MODE_ADD) )
             {
-              if( (*arg == ':') && (whatt & MODE_ADD) )
-                {
-                  parc--;
-                  parv++;
-                  break;
-                }
-              arg = collapse(pretty_mask(arg));
+              parc--;
+              parv++;
+              break;
             }
+            arg = collapse(pretty_mask(arg));
+          }
 
           tmp = strlen(arg);
           if (len + tmp + 2 >= MODEBUFLEN)
             break;
 
-          if (!(((whatt & MODE_ADD) && !add_banid(sptr, chptr, arg)) ||
+          if(!(((whatt & MODE_ADD) && !add_banid(sptr, chptr, arg)) ||
                 ((whatt & MODE_DEL) && !del_banid(chptr, arg))))
             break;
 
@@ -1874,15 +1982,19 @@
            * -Dianora
            */
 
-        case 'i' :
+        case 'i':
           if (whatt == MODE_QUERY)      /* shouldn't happen. */
             break;
-          if (!isok)
+          if(!isok
+#ifdef ENFORCE
+             && !enforced
+#endif
+             )
             {
-              if (MyClient(sptr) && !errsent(SM_ERR_NOOPS, &errors_sent))
-                sendto_one(sptr, form_str(ERR_CHANOPRIVSNEEDED), me.name, 
-                           sptr->name, chptr->chname);
-              break;
+                if(MyClient(sptr) && !errsent(SM_ERR_NOOPS, &errors_sent))
+                  sendto_one(sptr, form_str(ERR_CHANOPRIVSNEEDED), me.name,
+                             sptr->name, chptr->chname);
+                break;
             }
 
           if(MyClient(sptr))
@@ -1955,12 +2067,16 @@
           break;
 #endif
 
-        case 'm' :
-          if (!isok)
-            {
+        case 'm' :	    
+            if(!isok
+#ifdef ENFORCE
+               && !enforced
+#endif               
+              )
+	    {
               if (MyClient(sptr) && !errsent(SM_ERR_NOOPS, &errors_sent))
-                sendto_one(sptr, form_str(ERR_CHANOPRIVSNEEDED), me.name, 
-                           sptr->name, chptr->chname);
+                  sendto_one(sptr, form_str(ERR_CHANOPRIVSNEEDED), me.name, 
+                             sptr->name, chptr->chname);
               break;
             }
 
@@ -2008,12 +2124,21 @@
           break;
 
         case 'n' :
-          if (!isok)
-            {
-              if (MyClient(sptr) && !errsent(SM_ERR_NOOPS, &errors_sent))
-                sendto_one(sptr, form_str(ERR_CHANOPRIVSNEEDED), me.name, 
-                           sptr->name, chptr->chname);
-              break;
+            if(!isok)
+	    {
+#ifdef ENFORCE
+	      if(!IsEnforce(sptr))
+	      {	    
+#endif /* ENFORCE */
+                if (MyClient(sptr) && !errsent(SM_ERR_NOOPS, &errors_sent))
+                  sendto_one(sptr, form_str(ERR_CHANOPRIVSNEEDED), me.name, 
+                             sptr->name, chptr->chname);
+                break;
+#ifdef ENFORCE
+	      } else {	    
+		enforced = 1;
+	      }
+#endif /* ENFORCE */
             }
 
           if(MyClient(sptr))
@@ -2062,12 +2187,21 @@
         case 'p' :
           if (!isok)
             {
-              if (MyClient(sptr) && !errsent(SM_ERR_NOOPS, &errors_sent))
-                sendto_one(sptr, form_str(ERR_CHANOPRIVSNEEDED), me.name, 
-                           sptr->name, chptr->chname);
-              break;
+#ifdef ENFORCE
+	      if(!IsEnforce(sptr))
+	      {	    
+#endif /* ENFORCE */
+                if (MyClient(sptr) && !errsent(SM_ERR_NOOPS, &errors_sent))
+                  sendto_one(sptr, form_str(ERR_CHANOPRIVSNEEDED), me.name, 
+                             sptr->name, chptr->chname);
+                break;
+#ifdef ENFORCE
+	      } else {	    
+		enforced = 1;
+	      }
+#endif /* ENFORCE */
             }
-
+          
           if(MyClient(sptr))
             {
 #ifdef OLD_P_S
@@ -2131,10 +2265,19 @@
         case 's' :
           if (!isok)
             {
-              if (MyClient(sptr) && !errsent(SM_ERR_NOOPS, &errors_sent))
-                sendto_one(sptr, form_str(ERR_CHANOPRIVSNEEDED), me.name, 
-                           sptr->name, chptr->chname);
-              break;
+#ifdef ENFORCE
+	      if(!IsEnforce(sptr))
+	      {	    
+#endif /* ENFORCE */
+                if (MyClient(sptr) && !errsent(SM_ERR_NOOPS, &errors_sent))
+                  sendto_one(sptr, form_str(ERR_CHANOPRIVSNEEDED), me.name, 
+                             sptr->name, chptr->chname);
+                break;
+#ifdef ENFORCE
+	      } else {	    
+		enforced = 1;
+	      }
+#endif /* ENFORCE */
             }
 
           /* ickity poo, traditional +p-s nonsense */
@@ -2202,10 +2345,19 @@
         case 't' :
           if (!isok)
             {
-              if (MyClient(sptr) && !errsent(SM_ERR_NOOPS, &errors_sent))
-                sendto_one(sptr, form_str(ERR_CHANOPRIVSNEEDED), me.name, 
-                           sptr->name, chptr->chname);
-              break;
+#ifdef ENFORCE
+	      if(!IsEnforce(sptr))
+	      {	    
+#endif /* ENFORCE */
+                if (MyClient(sptr) && !errsent(SM_ERR_NOOPS, &errors_sent))
+                  sendto_one(sptr, form_str(ERR_CHANOPRIVSNEEDED), me.name, 
+                             sptr->name, chptr->chname);
+                break;
+#ifdef ENFORCE
+	      } else {	    
+		enforced = 1;
+	      }
+#endif /* ENFORCE */
             }
 
           if(MyClient(sptr))
@@ -2251,6 +2403,98 @@
             }
           break;
 
+#ifdef HAVE_SSL
+        case 'x':
+          
+          if(whatt == MODE_QUERY)      /* shouldn't happen. */
+            break;
+          
+          if(!isok
+#ifdef ENFORCE
+             && !enforced
+#endif
+             )
+            {
+              if(MyClient(sptr) && !errsent(SM_ERR_NOOPS, &errors_sent))
+                sendto_one(sptr, form_str(ERR_CHANOPRIVSNEEDED), me.name,
+                           sptr->name, chptr->chname);
+              break;
+            }
+
+          if(whatt == MODE_ADD)
+            {
+              if(!IsSSLChannel(chptr))
+                {
+                  sendto_one(sptr, ":%s NOTICE %s :Cannot set +x when not +z", me.name, sptr->name);
+                  break;
+                }
+              
+              if(len + 2 >= MODEBUFLEN)
+                break;
+#ifdef OLD_NON_RED
+              if(!IsSSLOnlyChannel(chptr))
+#endif
+                {
+                  SetSSLOnlyChannel(chptr);
+                  *mbufw++ = '+';
+                  *mbufw++ = 'x';
+                  len += 2;
+                }
+            }
+          else
+            {
+              if(len + 2 >= MODEBUFLEN)
+                break;
+
+#ifdef OLD_NON_RED
+              if(IsSSLOnlyChannel(chptr))
+#endif
+                {
+                  ClearSSLOnlyChannel(chptr);
+                  *mbufw++ = '-';
+                  *mbufw++ = 'x';
+                  len += 2;
+                }
+            }
+          break;
+          
+        case 'z':
+          
+          if(!IsServer(sptr)) /* users can't decide this */
+            break;
+                    
+          if(whatt == MODE_ADD)
+            {
+              if(len + 2 >= MODEBUFLEN)
+                break;
+
+              if(!IsSSLChannel(chptr))
+                {
+                  sendto_realops_flags(FLAGS_DEBUG, "Channel %s entered SSL mode (from %s)", chptr->chname, sptr->name);
+                  SetSSLChannel(chptr);  
+                  *mbufw++ = '+';
+                  *mbufw++ = 'z';
+                  len += 2;
+                }
+            }
+          else
+            {              
+              if(len + 2 >= MODEBUFLEN)
+                break;
+
+              if(whatt == MODE_DEL && IsSSLChannel(chptr))
+                {
+                  sendto_realops_flags(FLAGS_DEBUG, "Channel %s left SSL mode (from %s)", chptr->chname, sptr->name);
+                  ClearSSLChannel(chptr);
+                  *mbufw++ = '-';
+                  *mbufw++ = 'z';
+                  len += 2;
+                }
+            }
+          
+          break;
+#endif
+          
         default:
           if (whatt == MODE_QUERY)
             break;
@@ -2278,46 +2522,113 @@
   collapse_signs(modebuf_new);
   collapse_signs(modebuf_newer);
 
+
   if(*modebuf)
     {
+#ifdef ENFORCE
+      if(enforced)
+       {
+         if(sptr->host && *sptr->host)
+           sendto_realops("Enforced mode %s %son %s from %s (%s@%s)",
+  		          modebuf, parabuf, chptr->chname, sptr->name,
+                          sptr->username, sptr->host);
+         
+         if(IsServer(cptr))
+           sendto_channel_butserv(chptr, sptr, ":%s MODE %s %s %s", 
+                                  sptr->servptr->name, chptr->chname,
+                                  modebuf, parabuf);
+         else
+           sendto_channel_butserv(chptr, sptr, ":%s MODE %s %s %s", 
+                                  me.name, chptr->chname,
+                                  modebuf, parabuf);
+       }
+       else
+#endif        
 #ifdef HIDE_OPS
-      sendto_channel_chanops_butserv(chptr, sptr, ":%s MODE %s %s %s", 
-				     sptr->name, chptr->chname,
-				     modebuf, parabuf);
+         sendto_channel_chanops_butserv(chptr, sptr, ":%s MODE %s %s %s",
+                                        sptr->name, chptr->chname,  modebuf, parabuf);
 #else
-      sendto_channel_butserv(chptr, sptr, ":%s MODE %s %s %s", 
-                           sptr->name, chptr->chname,
-                           modebuf, parabuf);
+         sendto_channel_butserv(chptr, sptr, ":%s MODE %s %s %s",
+                                sptr->name, chptr->chname,  modebuf, parabuf);
 #endif
-      sendto_match_servs(chptr, cptr, ":%s MODE %s %s %s",
-                         sptr->name, chptr->chname,
-                         modebuf, parabuf);
+     
+       sendto_match_servs(chptr, sptr, ":%s MODE %s %s %s",
+                          sptr->name, chptr->chname,
+                          modebuf, parabuf);
     }
 
   if(*modebuf_new)
     {
-      sendto_channel_butserv(chptr, sptr, ":%s MODE %s %s %s", 
-                             sptr->name, chptr->chname,
-                             modebuf_new, parabuf_new);
+#ifdef ENFORCE
+       if(enforced)
+       {
+         if(sptr->host && *sptr->host)
+           sendto_realops("Enforced mode %s %son %s from %s (%s@%s)",
+	  	          modebuf_new, parabuf_new, chptr->chname, sptr->name,
+                          sptr->username, sptr->host);
 
-      sendto_match_cap_servs(chptr, cptr, CAP_EX, ":%s MODE %s %s %s",
-                             sptr->name, chptr->chname,
-                             modebuf_new, parabuf_new);
+         if(IsServer(cptr))
+           sendto_channel_butserv(chptr, sptr, ":%s MODE %s %s %s", 
+                                  sptr->servptr->name, chptr->chname,
+                                  modebuf_new, parabuf_new);
+         else
+           sendto_channel_butserv(chptr, sptr, ":%s MODE %s %s %s", 
+                                  me.name, chptr->chname,
+                                  modebuf_new, parabuf_new);
+       }
+       else
+#endif
+#ifdef HIDE_OPS
+         sendto_channel_chanops_butserv(chptr, sptr, ":%s MODE %s %s %s",
+                                        sptr->name, chptr->chname,  modebuf_new, parabuf_new);
+#else
+         sendto_channel_butserv(chptr, sptr, ":%s MODE %s %s %s",
+                                sptr->name, chptr->chname,  modebuf_new, parabuf_new);
+#endif
+     
+       sendto_match_servs(chptr, sptr, ":%s MODE %s %s %s",
+                          sptr->name, chptr->chname,
+                          modebuf_new, parabuf_new);
     }
+
   if(*modebuf_newer)
     {
-      sendto_channel_butserv(chptr, sptr, ":%s MODE %s %s %s",
-                             sptr->name, chptr->chname,
-                             modebuf_newer, parabuf_newer);
-      sendto_match_cap_servs(chptr, cptr, CAP_DE, ":%s MODE %s %s %s",
-                             sptr->name, chptr->chname,
-                             modebuf_newer, parabuf_newer);
-    }
+#ifdef ENFORCE
+      if(enforced)
+       {
+         if(sptr->host && *sptr->host)
+           sendto_realops("Enforced mode %s %son %s from %s (%s@%s)",
+	  	          modebuf_newer, parabuf_newer, chptr->chname, sptr->name,
+                          sptr->username, sptr->host);
 
+         if(IsServer(cptr))
+           sendto_channel_butserv(chptr, sptr, ":%s MODE %s %s %s", 
+                                  sptr->servptr->name, chptr->chname,
+                                  modebuf_newer, parabuf_newer);
+         else
+           sendto_channel_butserv(chptr, sptr, ":%s MODE %s %s %s", 
+                                  me.name, chptr->chname,
+                                  modebuf_newer, parabuf_newer);
+       }
+       else
+#endif
+#ifdef HIDE_OPS
+         sendto_channel_chanops_butserv(chptr, sptr, ":%s MODE %s %s %s",
+                                        sptr->name, chptr->chname,  modebuf_newer, parabuf_newer);
+#else
+         sendto_channel_butserv(chptr, sptr, ":%s MODE %s %s %s",
+                                sptr->name, chptr->chname,  modebuf_newer, parabuf_newer);
+#endif
+     
+       sendto_match_servs(chptr, sptr, ":%s MODE %s %s %s",
+                          sptr->name, chptr->chname,
+                          modebuf_newer, parabuf_newer);
+    }
                      
   return;
 }
 
+
 static  int     can_join(struct Client *sptr, struct Channel *chptr, char *key, int *flags)
 {
   Link  *lp;
